#!/usr/bin/python

import os
import sys
import pdb

print "=== TSC Converter (cross-platform) ==="
print "=========   By Carrot Lord   ========="
print ""

hextuple = ("\x00","\x01","\x02","\x03","\x04","\x05","\x06","\x07","\x08","\x09",
            "\x0a","\x0b","\x0c","\x0d","\x0e","\x0f",
            "\x10","\x11","\x12","\x13","\x14","\x15","\x16","\x17","\x18","\x19",
            "\x1a","\x1b","\x1c","\x1d","\x1e","\x1f",
            "\x20","\x21","\x22","\x23","\x24","\x25","\x26","\x27","\x28","\x29",
            "\x2a","\x2b","\x2c","\x2d","\x2e","\x2f",
            "\x30","\x31","\x32","\x33","\x34","\x35","\x36","\x37","\x38","\x39",
            "\x3a","\x3b","\x3c","\x3d","\x3e","\x3f",
            "\x40","\x41","\x42","\x43","\x44","\x45","\x46","\x47","\x48","\x49",
            "\x4a","\x4b","\x4c","\x4d","\x4e","\x4f",
            "\x50","\x51","\x52","\x53","\x54","\x55","\x56","\x57","\x58","\x59",
            "\x5a","\x5b","\x5c","\x5d","\x5e","\x5f",
            "\x60","\x61","\x62","\x63","\x64","\x65","\x66","\x67","\x68","\x69",
            "\x6a","\x6b","\x6c","\x6d","\x6e","\x6f",
            "\x70","\x71","\x72","\x73","\x74","\x75","\x76","\x77","\x78","\x79",
            "\x7a","\x7b","\x7c","\x7d","\x7e","\x7f",
            "\x80","\x81","\x82","\x83","\x84","\x85","\x86","\x87","\x88","\x89",
            "\x8a","\x8b","\x8c","\x8d","\x8e","\x8f",
            "\x90","\x91","\x92","\x93","\x94","\x95","\x96","\x97","\x98","\x99",
            "\x9a","\x9b","\x9c","\x9d","\x9e","\x9f",
            "\xa0","\xa1","\xa2","\xa3","\xa4","\xa5","\xa6","\xa7","\xa8","\xa9",
            "\xaa","\xab","\xac","\xad","\xae","\xaf",
            "\xb0","\xb1","\xb2","\xb3","\xb4","\xb5","\xb6","\xb7","\xb8","\xb9",
            "\xba","\xbb","\xbc","\xbd","\xbe","\xbf",
            "\xc0","\xc1","\xc2","\xc3","\xc4","\xc5","\xc6","\xc7","\xc8","\xc9",
            "\xca","\xcb","\xcc","\xcd","\xce","\xcf",
            "\xd0","\xd1","\xd2","\xd3","\xd4","\xd5","\xd6","\xd7","\xd8","\xd9",
            "\xda","\xdb","\xdc","\xdd","\xde","\xdf",
            "\xe0","\xe1","\xe2","\xe3","\xe4","\xe5","\xe6","\xe7","\xe8","\xe9",
            "\xea","\xeb","\xec","\xed","\xee","\xef",
            "\xf0","\xf1","\xf2","\xf3","\xf4","\xf5","\xf6","\xf7","\xf8","\xf9",
            "\xfa","\xfb","\xfc","\xfd","\xfe","\xff")

def display2():
    print "---------------"
    print ""

def error(msg):
    display2()
    print "Error. " + msg
    raw_input("Exiting program...")
    sys.exit()

def pause():
    raw_input("")

def tsc_to_txt(cipher):
    txtobj = open(nametxt,"wb")
    offtxt = 0
    offtsc = 0
    while (1):
        tscobj.seek(offtsc,0)
        txtobj.seek(offtxt,0)
        charTSC = tscobj.read(1)
        if (len(charTSC) != 1):
            print "Reached end of file."
            break
        else:
            tscobj.seek(offtsc,0)
            if ord(charTSC)==cipher: #if the character is the cipher itself
                txtobj.write(hextuple[cipher])
            else:
                txtobj.write(hextuple[ord(charTSC) - cipher]) #otherwise, use the cipher.
            #1. ord() will convert a char -> integer ASCII value.
            #2. subtract 0x20 to decode each char
            #3. hextuple it to convert to hex string
            #4. finally, write it to the file.
            offtxt += 1
            offtsc += 1 #increment both offsets by appropriate amounts.
        #endwhile
    return

def txt_to_tsc(cipher,middlelocation):
    tscobj = open(nametsc,"wb")
    offtxt = 0
    offtsc = 0
    while (1):
        tscobj.seek(offtsc,0)
        txtobj.seek(offtxt,0)
        charTXT = txtobj.read(1)
        if (len(charTXT) != 1):
            print "Reached end of file."
            break
        else:
            txtobj.seek(offtxt,0)
            if offtxt == middlelocation:
                tscobj.write(hextuple[cipher])
            else:
                if ord(charTXT) + cipher > 255:
                    #error("Hextuple is out of range.\nTrying to add " + hex(ord(charTXT)) + " with cipher " + str(cipher))
                    tscobj.write("\xff")
                else:
                    tscobj.write(hextuple[ord(charTXT) + cipher])
            #1. ord() will convert a char -> integer ASCII value.
            #2. add 0x20 to encode each char
            #3. hextuple it to convert to hex string
            #4. finally, write it to the file.
            offtxt += 1
            offtsc += 1 #increment both offsets by appropriate amounts.
        #endwhile
    return

def get_cipher():
    #tscobj is already opened
    #note that the code1 must always be 0D
    nldict = {} #create an empty newline dictionary.
    offtsc = 0
    while (1):
        tscobj.seek(offtsc,0)
        charTSC = tscobj.read(1)
        char2TSC = tscobj.read(1) #seeked position will automatically move forward
        if (len(charTSC) != 1) or (len(char2TSC) != 1):
            break #break the while if end of file is reached.
        code1 = ord(charTSC)
        code2 = ord(char2TSC)
        if (code1 - code2) == 3: #if the difference is 3, i.e. a newline character
            if nldict.has_key(code1): #if the dictionary contains the key already
                nldict[code1] += 1 #increment that key's value.
            else:
                nldict[code1] = 1 #set starting count.
        offtsc += 1  #increment offset.
        #endwhile
    listofkeys = nldict.keys()
    topvalue = 0
    topkey = "null"
    for keyx in listofkeys:
        if nldict[keyx] > topvalue:
            topkey = keyx
            topvalue = nldict[keyx]
    topkey -= 0x0D #0D compensates for ASCII 0D
    return topkey #the topkey is the cipher, in decimal.

def make_cipher():
    txtobj2 = open(nametxt,"rb") #open file for reading in binary
    charTEST = "-"
    while len(charTEST) == 1:
        charTEST = txtobj2.read(1) #find the end of the file.
    endfile = txtobj2.tell() #get end of file
    endfile = int(round(endfile/2)) #divide by 2, then round.
    txtobj2.seek(endfile,0)
    tuple1 = (ord(txtobj2.read(1)),endfile)
    return tuple1 #this is the [cipher in decimal,endfilelocation]

print "1: Convert TSC file to TXT"
print "2: Convert TXT file to TSC"
print "3: Exit program"
print ""
choice = raw_input("Enter a number:")
try:
    choice = int(choice)
except ValueError:
    error("You did not type in a number.")
else:
    if choice < 1 or choice > 3:
        error("You did not type in the number 1,2, or 3.")
    if choice == 1:
        display2()
        print "(Make sure the TSC file is in the same folder"
        print "as this program.)"
        print ""
        nametsc = raw_input("Type in the name of the TSC file:")
        maxlen = len(nametsc)
        checkext = nametsc[(maxlen - 4):maxlen] #check if there's a file extension or not.
        if (checkext != ".tsc"):
            nametxt = nametsc + ".txt" #set nametxt.
            nametsc = nametsc + ".tsc"
        else:
            nametxt = nametsc[0:(maxlen - 4)] + ".txt" #set nametxt the other way.
        try:
            tscobj = open(nametsc,"rb")
        except IOError:
            error("Cannot find the file " + nametsc)
        else:
            display2()
            print "Converting file " + nametsc + "..."
            cipher = get_cipher()
            tsc_to_txt(cipher)
            print "Conversion successful! Saved as " + nametxt
            pause()
            sys.exit()
    if choice == 2:
        display2()
        print "(Make sure the TXT file is in the same folder"
        print "as this program.)"
        print ""
        nametxt = raw_input("Type in the name of the TXT file:")
        maxlen = len(nametxt)
        checkext = nametxt[(maxlen - 4):maxlen] #check if there's a file extension or not.
        if (checkext != ".txt"):
            nametsc = nametxt + ".tsc"
            nametxt = nametxt + ".txt" #set nametxt.
        else:
            nametsc = nametxt[0:(maxlen - 4)] + ".tsc" #set nametsc the other way.
        try:
            txtobj = open(nametxt,"rb")
        except IOError:
            error("Cannot find the file " + nametxt)
        else:
            display2()
            print "Converting file " + nametxt + "..."
            tuplebasic = make_cipher()
            txt_to_tsc(tuplebasic[0],tuplebasic[1])
            print "Conversion successful! Saved as " + nametsc
            pause()
            sys.exit()
    if choice == 3:
        sys.exit()
